<template>
  <div>
    <mt-page-title>
      <h1 class="has-text-weight-bold is-size-3">Liste des types disponibilités</h1>
    </mt-page-title>
    <div>
      <div class="columns is-vcentered mt-marginless-bottom">
        <h3 class="has-text-weight-bold has-text-grey is-size-5 column">
          Nombre total des types disponibilités : {{ total }}
        </h3>
        <div class="column is-narrow">
          <nuxt-link
            :to="{ name: 'profil-dashboard-typedisponibilite-creer', params: { profil: 'admin' } }"
            tag="button"
            class="is-primary button"
          >
            <b-icon icon="plus" />
            Créer un type disponibilité
          </nuxt-link>
        </div>
      </div>
      <mt-list v-slot="{ item: typesDisponibilites }" :list="typesDisponibilites">
        <mt-list-item>
          <div class="columns is-vcentered">
            <nuxt-link
              :to="{
                name: 'profil-dashboard-typedisponibilite-id-editer',
                params: { profil: 'admin', id: typesDisponibilites.id },
              }"
              class="columns column mt-marginless-bottom"
            >
              <div class="column">{{ typesDisponibilites.code }}</div>
              <div class="column">{{ typesDisponibilites.libelle }}</div>
              <div class="column">{{ changeValue(typesDisponibilites.estDisponible) }}</div>
            </nuxt-link>
            <div class="column is-narrow">
              <b-button type="is-danger" icon-left="delete" @click="confirmeSupprimer(typesDisponibilites)"
                >Supprimer</b-button
              >
            </div>
          </div>
        </mt-list-item>
      </mt-list>
      <mt-modal-action
        type-delete
        :ouvert.sync="ouvertDelete"
        @action="supprimerTypeDisponibilite(monTypeDisponibilite)"
      >
        Êtes-vous certain(e) de vouloir supprimer le type de disponibilité ?
      </mt-modal-action>
      <b-pagination
        :total="total"
        :current="pageCourante"
        :per-page="parPage"
        order="is-centered"
        aria-next-label="Type disponibilité suivante"
        aria-previous-label="Type disponibilité précedente"
        aria-page-label="Type disponibilité"
        aria-current-label="Page courante"
        @change="getTypeDisponibilites"
      />
    </div>
  </div>
</template>
<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtList from '~/components/base/list/index';
import MtListItem from '~/components/base/list/list-item';
import MtModalAction from '~/components/modal/mt-modal-action';

export default {
  layout: 'dashboard',
  components: {
    MtPageTitle,
    MtList,
    MtListItem,
    MtModalAction,
  },
  async asyncData({ $api }) {
    const pageCourante = 1;
    const parPage = 10;
    const {
      content: typesDisponibilites,
      totalElements: total,
      numberOfElements: nombrePageCourante,
    } = await $api.typesDisponibilites.allPage(pageCourante - 1, parPage);
    return {
      typesDisponibilites,
      pageCourante,
      parPage,
      total,
      nombrePageCourante,
      ouvertDelete: false,
      monTypeDisponibilite: null,
    };
  },
  methods: {
    changeValue(typeDispo) {
      let estDisponible = '';
      if (typeDispo === true) {
        estDisponible = 'Disponible';
      } else {
        estDisponible = 'Indisponible';
      }
      return estDisponible;
    },
    async getTypeDisponibilites(page) {
      this.pageCourante = page;
      ({
        content: this.typesDisponibilites,
        totalElements: this.total,
        numberOfElements: this.nombrePageCourante,
      } = await this.$api.typesDisponibilites.allPage(this.pageCourante - 1, this.parPage));
    },
    confirmeSupprimer(typesDisponibilites) {
      this.ouvertDelete = true;
      this.monTypeDisponibilite = typesDisponibilites;
    },
    async supprimerTypeDisponibilite(typesDisponibilites) {
      try {
        await this.$api.typesDisponibilites.delete(typesDisponibilites.id);
        let page = this.pageCourante;
        if (this.nombrePageCourante === 1 && this.pageCourante > 1) {
          page = this.pageCourante - 1;
        }
        this.getTypeDisponibilites(page);
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
  },
};
</script>

<style scoped lang="scss">
/deep/ {
  .mt-list {
    margin-top: 0.5rem;
  }
}
</style>
